﻿// NMTreeCtrl.cpp : 구현 파일입니다.
//

#include "stdafx.h"
#include "NeMessenger.h"
#include "NMFavoriteTreeCtrl.h"
#include "NeMessengerDlg.h"
#include "MainDlg.h"

#include "CursorDef.h"

#include <locale.h>

// CNMFavoriteTreeCtrl
#pragma warning(4:4503)		// decorated name length exceeded

enum ECmdHandler {
	ID_RENAME = 1,
	ID_DELETE,
	ID_ADD_SIBLING,
	ID_ADD_CHILD,
	ID_ADD_ROOT,
	ID_SORT_LEVEL,
	ID_SORT_LEVELANDBELOW,
	ID_MAX_CMD
};

enum ERightDragHandler {
	ID_DRAG_COPY = 15,
	ID_DRAG_MOVE,
	ID_DRAG_CANCEL,
	ID_MAX_DRH
};

IMPLEMENT_DYNAMIC(CNMFavoriteTreeCtrl, CTreeCtrl)

CNMFavoriteTreeCtrl::cursormap_t CNMFavoriteTreeCtrl::m_Cursormap;

static int g_nDropFlag = 1;
static bool g_bCurrentitem = false;
static bool g_bTrgetItem = false;

CNMFavoriteTreeCtrl::CNMFavoriteTreeCtrl()
	: m_pDragData(0)	
{
//	m_pProfileDlg = NULL;
	m_pMemoSend =NULL;


}

CNMFavoriteTreeCtrl::~CNMFavoriteTreeCtrl()
{
/*	if(m_pProfileDlg)
	{
		delete m_pProfileDlg;
		m_pProfileDlg = NULL;
	}*/

	if(m_pMemoSend)
	{
		delete m_pMemoSend;
		m_pMemoSend = NULL;
	}
}


BEGIN_MESSAGE_MAP(CNMFavoriteTreeCtrl, CTreeCtrl)
	ON_NOTIFY_REFLECT(NM_RCLICK, &CNMFavoriteTreeCtrl::OnNMRClick)
	ON_WM_CONTEXTMENU()	
	ON_NOTIFY_REFLECT(TVN_BEGINLABELEDIT, &CNMFavoriteTreeCtrl::OnTvnBeginlabeledit)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT, &CNMFavoriteTreeCtrl::OnTvnEndlabeledit)
	ON_NOTIFY_REFLECT(TVN_BEGINDRAG, OnBegindrag)
//	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
//	ON_NOTIFY_REFLECT(TVN_BEGINRDRAG, OnBeginrdrag)
	ON_NOTIFY_REFLECT(TVN_SELCHANGING, OnSelchanging)
	ON_WM_MOUSEMOVE()
//	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_NCRBUTTONDOWN()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()



// CNMFavoriteTreeCtrl 메시지 처리기입니다.



void CNMFavoriteTreeCtrl::OnNMRClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	OutputDebugString(_T("\r\n##### CNMFavoriteTreeCtrl::OnNMRClick"));	
	SendMessage(WM_CONTEXTMENU, (WPARAM)m_hWnd, GetMessagePos());
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	*pResult = 0;
}

void CNMFavoriteTreeCtrl::OnContextMenu(CWnd* pWnd, CPoint point)
{
// Notes: 선택(오른쪽 마우스 버튼 클릭 -> 다중 선택 차단 처리 테스트 중입니다.) 수정 필요시 (담당자와 협의 요망)
// Deat : 2012.01.26
#if 0
	CMainDlg* pParent = (CMainDlg*)this->
		();
	HTREEITEM hGetTreeItem = pParent->m_ctrlFavoriteTree.GetSelectedItem();
	if(hGetTreeItem != NULL)
	{
		pParent->m_ctrlFavoriteTree.ClearSelection();
		pParent->m_ctrlFavoriteTree.SelectItem(hGetTreeItem);	
		SetItemState(hGetTreeItem, UINT(TVIS_SELECTED), UINT(TVIS_SELECTED));
		UpdateWindow();
	}
	else
	{
		//AfxMessageBox(_T("Not Selected"));	
		UINT uFlags ;
		HTREEITEM hNew = HitTest( point, &uFlags ) ;
		SetItemState(hNew, UINT(TVIS_SELECTED), UINT(TVIS_SELECTED));
		UpdateWindow();
	}
#endif

	CString strDbg;
	CString strCurItemText = _T("");
	CString strCurItemID = _T("");
	ScreenToClient(&point);

	UINT uFlags;
	HTREEITEM hItem;
	hItem = HitTest(point, &uFlags);

	if(hItem == NULL)		return;

	this->SelectItem(hItem);
	strCurItemText = this->GetItemText(hItem);
	const NE_MEMBER_DATA* pItem = (const NE_MEMBER_DATA*)this->GetItemData(hItem);
	if (pItem)
		strCurItemID.Format(_T("%s"),pItem->strUserId.c_str());
	//OutputDebugString(strText);

	CMenu menu;
	CMenu* pPopup;	
	menu.LoadMenu(IDR_MEMU_COMMON_MENU);	


	
	CNeMessengerDlg* pParentDlg = (CNeMessengerDlg*)this->GetParent();
	strCurItemText = pParentDlg->GetFilterName(strCurItemText);										//02.07 사용자 정보를 (?/?) 삭제 한다.			
	


	GROUP_LIST::iterator iter = m_GroupList.find(strCurItemText.GetBuffer());						
	this->GetItemImage(hItem,m_nImage,m_nSelectedImage);				

	//if(iter == m_vecGroupList.end()) //user context
	if(iter == m_GroupList.end()) //user context
	{
		pPopup = menu.GetSubMenu(4);

		if(m_nSelectedImage == 0)										
		{
			pPopup->EnableMenuItem(ID__CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}

		CMenu* pCopyGroupItem = pPopup->GetSubMenu(5);
		CMenu* pMoveGroupItem = pPopup->GetSubMenu(6);
		for(int i = pCopyGroupItem->GetMenuItemCount() - 1; i > -1; i--)
			pCopyGroupItem->DeleteMenu(i, MF_BYPOSITION);
		for(int i = pMoveGroupItem->GetMenuItemCount() - 1; i > -1; i--)
			pMoveGroupItem->DeleteMenu(i, MF_BYPOSITION);		
		int i = 0;
		for(GROUP_LIST::iterator idx = m_GroupList.begin(); idx != m_GroupList.end(); idx++)
		{			
			pCopyGroupItem->AppendMenuW(MF_STRING, ID_COPYGROUPLIST_START + i, idx->first);
			pMoveGroupItem->AppendMenuW(MF_STRING, ID_MOVEGROUPLIST_START + i, idx->first);			
			i++;
		}
	}
	else //group context
	{
		pPopup = menu.GetSubMenu(5);
	}
	
	ClientToScreen(&point);
	int nCmdID = pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RETURNCMD, point.x, point.y, this);
	strDbg.Format(_T("\r\n##### CmdID : %d"), nCmdID);
	OutputDebugString(strDbg);

	//HTREEITEM hItem = this->GetSelectedItem();
	switch(nCmdID)
	{
	case 32813: // 사용자:대화상대정보
		{
	/*		if(m_pProfileDlg)
			{
				delete m_pProfileDlg;
				m_pProfileDlg = NULL;			}*/

			CProfileDlg::CreateDlg(strCurItemID, _T("대화상대 정보"));
		/*	CNeMessengerApp* pParent = (CNeMessengerApp*)AfxGetApp();

			CProfileDlg *pProfileDlg = new CProfileDlg(NULL);			
			pProfileDlg->Create(strCurItemID, pParent->m_listProfileDlg.GetCount(), CProfileDlg::IDD,NULL);
			pProfileDlg->SetTitle(_T("대화상대 정보"));			
		//	SetWindowPosToSide(this, pProfileDlg);
		//	pProfileDlg->RequestInfo();
			pProfileDlg->ShowWindow(SW_SHOW);			
			pParent->m_listProfileDlg.AddTail((CObject*)pProfileDlg);*/
		}
		break;
	case ID__CHAT: // 사용자:대화하기
		{
			CMainDlg* pParent = (CMainDlg*)this->GetParent();
			pParent->m_pMessengerMain->OnTopMenuChat();
		}
		break;
	case 32815: // 사용자:쪽지보내기
		{	

			//if(m_pMemoSend)
			//{
			//	delete m_pMemoSend;
			//	m_pMemoSend = NULL;
			//}
			CStringArray arrToUser;
			arrToUser.RemoveAll();
			arrToUser.Add(strCurItemID);

			CMemoSendDlg::MakeMemoSendDlg(&arrToUser, CMemoSendDlg::IDD, this->GetDesktopWindow());
		}
		break;
	case 32822: // 사용자:대화상대 삭제
		DelFavoriteUser();
		break;
	case 32823: // 그룹:대화하기
		{		
			CMainDlg* pParent = (CMainDlg*)this->GetParent();
			pParent->m_pMessengerMain->OnTopMenuChat();
		}
		break;
	case 32824: // 그룹:쪽지보내기
		{		
			CMainDlg* pParent = (CMainDlg*)this->GetParent();
			pParent->m_pMessengerMain->OnTopMenuSendMemo();
		}

		break;
	case 32825: // 그룹:그룹만들기
		{
			AddGroup();					

//			HTREEITEM hmyItem = this->GetSelectedItem();		
//			::SendMessage((HWND)this->m_hWnd,  TVM_EDITLABEL ,(WPARAM)0,(LPARAM)(HTREEITEM)hmyItem);			//WPARAM is Not Used

		}
		break;
	case 32826: // 그룹:그룹이름바꾸기
		{			
			this->EditLabel(hItem);
		}
		break;
	case 32827: // 그룹:그룹삭제
		{
			//CString strText = this->GetItemText(hItem);
			//AfxMessageBox(strCurItemText);
			DelGroup(strCurItemText);
		}
		break;
	default:
		{
			//CString strTargetGroupText;
			if(nCmdID >= ((int)ID_COPYGROUPLIST_START) && nCmdID < ((int)ID_COPYGROUPLIST_END))
			{
				//int nTmp = 0;
				//nTmp = (int)nCmdID - ((int)ID_COPYGROUPLIST_START);
				//strDbg.Format(_T("\r\n##### nCmdID : %d, nTmp : %d, id : %d"), nCmdID, nTmp, ID_COPYGROUPLIST_START);
				//OutputDebugString(strDbg);
				
				GROUP_LIST::iterator iter = m_GroupList.begin();
				//int nTmp = nCmdID - ID_COPYGROUPLIST_START -1;
				//strDbg.Format(_T("\r\n##### [context menu->copylist] nTmp : %d, nCmdID : %d, ddd:%d"), nTmp, nCmdID, ID_COPYGROUPLIST_START);
				//OutputDebugString(strDbg);
				for(int idx = 0; idx < (nCmdID - ((int)ID_COPYGROUPLIST_START)); idx++)
					iter++;
				int nGroupId = iter->second;
				//strDbg.Format(_T("\r\n##### [context menu->copylist] group id : %d"), nGroupId);
				//OutputDebugString(strDbg);				
				AddFavoriteUser(nGroupId, strCurItemID);
				
			}
			else if(nCmdID >= ((int)ID_MOVEGROUPLIST_START) && nCmdID < ((int)ID_MOVEGROUPLIST_END))
			{
				GROUP_LIST::iterator iter = m_GroupList.begin();
				//int nTmp = nCmdID - ID_MOVEGROUPLIST_START -1;
				//strDbg.Format(_T("\r\n##### [context menu->copylist] nTmp : %d, nCmdID : %d, ddd:%d"), nTmp, nCmdID, ID_COPYGROUPLIST_START);
				//OutputDebugString(strDbg);
				for(int idx = 0; idx < (nCmdID - ((int)ID_MOVEGROUPLIST_START)); idx++)
					iter++;
				int nGroupId = iter->second;
				//strDbg.Format(_T("\r\n##### [context menu->copylist] group id : %d"), nGroupId);
				//OutputDebugString(strDbg);				
				//AddFavoriteUser(nGroupId, strCurItemText);
				//DelFavoriteUser();

			}
		}
		break;
	}

#if 1
	CMainDlg* pParent = (CMainDlg*)this->GetParent();
	HTREEITEM hGetTreeItem = pParent->m_ctrlFavoriteTree.GetSelectedItem();
	if(hGetTreeItem != NULL)
	{
		pParent->m_ctrlFavoriteTree.ClearSelection();
		pParent->m_ctrlFavoriteTree.SelectItem(hGetTreeItem);	
		SetItemState(hGetTreeItem, UINT(TVIS_SELECTED), UINT(TVIS_SELECTED));
		UpdateWindow();
	}
	else
	{
		//AfxMessageBox(_T("Not Selected"));	
		UINT uFlags ;
		HTREEITEM hNew = HitTest( point, &uFlags ) ;
		SetItemState(hNew, UINT(TVIS_SELECTED), UINT(TVIS_SELECTED));
		UpdateWindow();
	}


	

#endif

	//pParent->m_ctrlFavoriteTree.RedrawWindow();
	//UpdateWindow();

	menu.DestroyMenu();
	
}

void CNMFavoriteTreeCtrl::SetGroupList(GROUP_LIST &mapGroupList)
{
	if(m_GroupList.empty() == false)
		m_GroupList.clear();
	m_GroupList = mapGroupList;
}


GROUP_LIST CNMFavoriteTreeCtrl::GetGroupList()
{
	return m_GroupList;
}

// 대화상대 삭제
int CNMFavoriteTreeCtrl::DelFavoriteUser(void)
{
	int nGroupId = 0;
	HTREEITEM hItem = GetSelectedItem();
	if(hItem == NULL)
		return 0;

	HTREEITEM hParentItem = this->GetParentItem(hItem);
	
	
	CString strParentItemText = this->GetItemText(hParentItem);

	CNeMessengerDlg* pParentDlg = (CNeMessengerDlg*)this->GetParent();
	strParentItemText = pParentDlg->GetFilterName(strParentItemText);										//02.07 사용자 정보를 (?/?) 삭제 한다.			

	GROUP_LIST::iterator iter = m_GroupList.find(strParentItemText);


	if(iter == m_GroupList.end())
		return 0;
	else
		nGroupId = iter->second;


	CString strItemText = this->GetItemText(hItem);
	CMainDlg* pParent = (CMainDlg*)this->GetParent();
	pParent->m_pMessengerMain->ProcDelFavorite(nGroupId, strItemText);
	return 0;
}

// 그룹 추가
int CNMFavoriteTreeCtrl::AddGroup(void)
{

//Default
	CMainDlg* pParent = (CMainDlg*)this->GetParent();
	pParent->m_pMessengerMain->ProcAddGroup();   	

	HTREEITEM hmyItem = this->GetSelectedItem();				//새로 선택된	
	::SendMessage((HWND)this->m_hWnd,  TVM_EDITLABEL ,(WPARAM)0,(LPARAM)(HTREEITEM)hmyItem);			//WPARAM is Not Used , working, this line */	
	
/*	pParent->m_ctrlFavoriteTree.ClearSelection(0);
	HTREEITEM hItem = pParent->m_ctrlFavoriteTree.GetSelectedItem();
	pParent->m_ctrlFavoriteTree.EditLabel(hItem);
	pParent->m_ctrlFavoriteTree.CallDoInsertRoot(hItem);*/
	return 0;
}


// 그룹삭제
int CNMFavoriteTreeCtrl::DelGroup(CString strGroup)
{
	GROUP_LIST::iterator iter = m_GroupList.find(strGroup);
	if(iter != m_GroupList.end())
	{
		CMainDlg* pParent = (CMainDlg*)this->GetParent();
		pParent->m_pMessengerMain->ProcDelGroup(iter->second);
	}
	else
	{
		OutputDebugString(_T("\r\n##### [DelGroup] : 그룹리스트에 없는 그룹명"));
	}
	return 0;
}
void CNMFavoriteTreeCtrl::OnTvnBeginlabeledit(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVDISPINFO pTVDispInfo = reinterpret_cast<LPNMTVDISPINFO>(pNMHDR);
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	CString strBuffer;
	CEdit* pEdit = this->GetEditControl();
	pEdit->GetWindowTextW(strBuffer);	

	m_strCurEditLabelText = strBuffer;
	OutputDebugString(m_strCurEditLabelText);
	*pResult = 0;
}

void CNMFavoriteTreeCtrl::OnTvnEndlabeledit(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVDISPINFO pTVDispInfo = reinterpret_cast<LPNMTVDISPINFO>(pNMHDR);
	// TODO: 여기에 컨트롤 알림 처리기 코드를 추가합니다.
	CString strBuffer;
	CEdit* pEdit = this->GetEditControl();
	pEdit->GetWindowTextW(strBuffer);
	

	if(strBuffer.IsEmpty() == FALSE && m_strCurEditLabelText != strBuffer)
	{
		CString strDbg;
		strDbg.Format(_T("\r\n##### cur : %s, new : %s #####\r\n"), m_strCurEditLabelText, strBuffer);
			OutputDebugString(strDbg);		
		CMainDlg* pParent = (CMainDlg*)this->GetParent();	
		int nCurGroupId = GetGroupId(m_strCurEditLabelText);
		m_strCurEditLabelText = _T("");
		pParent->m_pMessengerMain->ProcRenameGroupName(nCurGroupId, strBuffer);
	}

	TVITEM & item = pTVDispInfo->item;
	*pResult = 1;

	if(item.pszText) {
		SetItem(&item);
		*pResult = 0;
	}
//	EditLableOff();			//2012.01.09
	*pResult = 0;
}

// 새 그룹명
CString CNMFavoriteTreeCtrl::GetNewGroupName()
{
	
	CString strNewGroupName(_T("새그룹"));
	int idx = 0;
	CString strGroupName;	
	strGroupName = strNewGroupName;	
	while(1)
	{		
		GROUP_LIST::iterator iter = m_GroupList.find(strGroupName);
		if(iter == m_GroupList.end())
			break;
		idx++;		
		strGroupName.Format(_T("%s(%d)"), strNewGroupName, idx);		//새그룹(0)...
	}

	//strGroupName.Append(_T("(0/0)"));
	strNewGroupName = strGroupName;	
	return strNewGroupName;		
}

// 그룹 아이디
int CNMFavoriteTreeCtrl::GetGroupId(CString strGroupName)
{
	CString strDbg;
	int nGroupId = -1;
	GROUP_LIST::iterator iter = m_GroupList.find(strGroupName);
	if(iter != m_GroupList.end())
	{
		nGroupId = iter->second;
		strDbg.Format(_T("\r\n###### [GetGroupId] group id : %d"), nGroupId);
		OutputDebugString(strDbg);
	}
	return nGroupId;
}

static void SetupInsertStruct(TVINSERTSTRUCT & ins, HTREEITEM hParent) {
	memset(&ins, 0, sizeof(ins));
	ins.item.mask = TVIF_TEXT;
	ins.item.pszText = _T("새 그룹");
	ins.hParent = hParent;
	ins.hInsertAfter = TVI_LAST;
}

// user 추가
int CNMFavoriteTreeCtrl::AddFavoriteUser(int nGroupId, CString strUserId)
{
	CMainDlg* pParent = (CMainDlg*)this->GetParent();
	// groupid, userid
	pParent->m_pMessengerMain->ProcAddFavorite(nGroupId, strUserId);

	return 0;
}

bool CNMFavoriteTreeCtrl::NewItem(TVINSERTSTRUCT & ins) {
	TRACE1("CEditTreeCtrl::NewItem('%s')\n", ins.item.pszText ? ins.item.pszText : _T("NULL"));
	
	HTREEITEM hItem = InsertItem(&ins);
	if(hItem) {
		//OnNewItem(hItem);
		SelectItem(hItem);		
		EditLabel(hItem);
	}
	return hItem != 0;
}

void CNMFavoriteTreeCtrl::OnNewItem(HTREEITEM) {
}


// --------------------------------------------------------------------------
// Dragging
CDragData * CNMFavoriteTreeCtrl::CreateDragData(HTREEITEM hDragItem, bool bRightDrag) {
	return new CDragData(*this, hDragItem, bRightDrag);
}

bool CNMFavoriteTreeCtrl::IsAncestor(HTREEITEM hItem, HTREEITEM hCheck) const
{
	for(HTREEITEM hParent = hCheck; hParent != 0; hParent = GetParentItem(hParent))
		if(hParent == hItem)
			return true;
	return false;
}

void CNMFavoriteTreeCtrl::DragMoveItem(HTREEITEM hDrag, HTREEITEM hDrop, EDropHint eHint, bool bCopy)
{
	if(eHint == DROP_NODROP)
		return;

	if(IsAncestor(hDrag, hDrop) || !CanDropItem(hDrag, hDrop, eHint))
		return;

	ASSERT(hDrag != 0);
	ASSERT(hDrop != 0 || eHint == DROP_BELOW);

	if(!hDrop && eHint == DROP_BELOW)
		for(hDrop = GetRootItem(); GetNextSiblingItem(hDrop) != 0; hDrop = GetNextSiblingItem(hDrop));

	// Setup insertion parameters
	HTREEITEM hInsertAfter = 0;
	HTREEITEM hParent = 0;
	switch(eHint) {
		case DROP_BELOW:
			hInsertAfter = hDrop;
			hParent = GetParentItem(hDrop);
			break;

		case DROP_ABOVE:
			hInsertAfter = GetPrevSiblingItem(hDrop);
			if(!hInsertAfter)
				hInsertAfter = TVI_FIRST;
			hParent = GetParentItem(hDrop);
			break;

		case DROP_CHILD:
			hInsertAfter = TVI_LAST;
			hParent = hDrop;
			break;

		default:
			ASSERT(false);
			break;
	}

	HTREEITEM hNew = CopyItem(hDrag, hParent, hInsertAfter);
	SelectItem(hNew);

	// If the control-key ist down, we copy the data, otherwise we move
	// it, thus we have to delete the dragged item.
	if(!bCopy)
		DeleteItem(hDrag);
}

void CNMFavoriteTreeCtrl::DragStart(void)
{
	ASSERT(m_pDragData != 0);
	TRACE1("CEditTreeCtrl::DragStart('%s')\n", LPCTSTR(GetItemText(m_pDragData->GetDragItem())));
	 int nNumSelected = GetSelectedCount();	
	if(nNumSelected == 1) {
		m_pDragData->StartDrag();
		SelectItem(m_pDragData->GetDragItem());
	}
	else
		m_pDragData->StartDrag();
}

void CNMFavoriteTreeCtrl::DragStop(void)
{
	TRACE0("CNMFavoriteTreeCtrl::DragStop()\n");	
	ASSERT(m_pDragData != 0);
	m_pDragData->EndDrag();
	delete m_pDragData;
	m_pDragData = 0;

		
	CString strUserIDlist	= _T("");
	CString strUserInfo		 = _T("");		
	bool nFlag =	 true;

	CMainDlg* pParentDlg = (CMainDlg*)this->GetParent();

	for(HTREEITEM hRootItem = pParentDlg->m_ctrlFavoriteTree.GetRootItem(); hRootItem != 0; hRootItem = pParentDlg->m_ctrlFavoriteTree.GetNextSiblingItem(hRootItem))
	{
		for(HTREEITEM hChildItem = pParentDlg->m_ctrlFavoriteTree.GetChildItem(hRootItem); hChildItem != 0; hChildItem = pParentDlg->m_ctrlFavoriteTree.GetNextSiblingItem(hChildItem))
		{			
//			if (m_bLogin == FALSE)
			//	strUserInfo = pParentDlg->m_ctrlFavoriteTree.GetItemText(hChildItem);
			//else
			{
				const NE_MEMBER_DATA* pItem = (const NE_MEMBER_DATA*)pParentDlg->m_ctrlFavoriteTree.GetItemData(hChildItem);
				if (pItem)
					strUserInfo.Format(_T("%s"), pItem->strUserId.c_str());
			}
			if(nFlag == true)
			{
			
				strUserIDlist = strUserInfo;
				nFlag = false;
				continue;
			}			
			strUserIDlist.Append(_T("|"));
			strUserIDlist.Append( strUserInfo);

		}
	}
	trid_t trid(6951);
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	pWASActor->RequestEmplyeeInfo(strUserIDlist,&trid);
	

	


}

void CNMFavoriteTreeCtrl::DragEnd(void)
{
	ASSERT(m_pDragData != 0);
	TRACE1("CNMFavoriteTreeCtrl::DragEnd('%s')\n", LPCTSTR(GetItemText(m_pDragData->GetDragItem())));

	EDropHint eHint;
	HTREEITEM hDrop = GetDropTarget(eHint);
	
	bool bCtrl = (::GetKeyState(VK_CONTROL) & 0x8000) != 0;
	DragMoveItem(m_pDragData->GetDragItem(), hDrop, eHint, bCtrl);
	DragStop();	
}

bool CNMFavoriteTreeCtrl::DoInsertRoot(HTREEITEM hItem) {
	TRACE1("CEditTreeCtrl::OnInsertRoot('%s')\n", LPCTSTR(GetItemText(hItem)));
	TVINSERTSTRUCT ins;	
	SetupInsertStruct(ins, TVI_ROOT);
	return NewItem(ins);
}

bool CNMFavoriteTreeCtrl::DoDeleteItem(HTREEITEM hItem)
{
	TRACE1("CNMFavoriteTreeCtrl::OnDeleteItem('%s')\n", LPCTSTR(GetItemText(hItem)));
	return hItem ? (CanDeleteItem(hItem) && DeleteItem(hItem)) : false;
}

void CNMFavoriteTreeCtrl::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult) 
{	
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	*pResult = 0;	

	if(CanDragItem(pNMTreeView->itemNew)) {
		m_pDragData = CreateDragData(pNMTreeView->itemNew.hItem, false);
		DragStart();
	}
}

void CNMFavoriteTreeCtrl::OnSelchanging(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	*pResult = 0;
	UINT & action = pNMTreeView->action;
	if(action == TVC_UNKNOWN) {

		if(m_pDragData) {

			if(!(pNMTreeView->itemNew.state & TVIS_SELECTED)) {
				HTREEITEM hNew = pNMTreeView->itemNew.hItem;
				SetItemState(hNew, UINT(TVIS_SELECTED), UINT(TVIS_SELECTED));				
				m_pDragData->ReleaseDragImage();
				m_pDragData->CreateDragImage();
			}
		}
	}			
}

bool CNMFavoriteTreeCtrl::CanDropItem(HTREEITEM hDrag, HTREEITEM hDrop, EDropHint hint)
{
	TRACE2("CNMFavoriteTreeCtrl::CanDropItem('%s', '%s')\n", LPCTSTR(GetItemText(hDrag)), LPCTSTR(GetItemText(hDrop)));
	return true;
}

HTREEITEM CNMFavoriteTreeCtrl::CopyItem(HTREEITEM hOrig, HTREEITEM hParent, HTREEITEM hInsertAfter)
{
// Notes : Drag & Drop 실행 시 오류 , 수정 전					// question : The Modifyed Line necessity for Chatting windows Bug fix ???
/*	// Get item information
	TVITEMEX item;
	memset(&item, 0, sizeof(item));
	item.mask = TVIF_TEXT|TVIF_IMAGE|TVIF_PARAM;//TVIF_HANDLE|TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_STATE|TVIF_INTEGRAL ;
	item.stateMask = TVIS_OVERLAYMASK|TVIS_STATEIMAGEMASK;
	item.hItem = hOrig;
	VERIFY(GetItem((TVITEM*)&item));
	CString strText = GetItemText(hOrig);

	// Insert new item and copy data
	HTREEITEM hNew = InsertItem( item.mask, _T("strText"), item.iImage, item.iSelectedImage, item.state, item.stateMask, item.lParam, hParent, hInsertAfter);
	//HTREEITEM hNew = InsertItem(strText, hParent, hInsertAfter);
	ASSERT(hNew != 0);
	item.hItem = hNew;
	VERIFY(SetItem((TVITEM*)&item));	
	if(ItemHasChildren(hOrig))
		for(HTREEITEM hChild = GetChildItem(hOrig); hChild != 0; hChild = GetNextSiblingItem(hChild))
			CopyItem(hChild, hNew, TVI_LAST);
	return hNew; */

// maxk Value 수정 & Insert Value 수정.

	// Get item information
	TVITEMEX item;
	memset(&item, 0, sizeof(item));
	item.mask = TVIF_HANDLE|TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_STATE|TVIF_INTEGRAL ;
	item.stateMask = TVIS_OVERLAYMASK|TVIS_STATEIMAGEMASK;
	item.hItem = hOrig;
	VERIFY(GetItem((TVITEM*)&item));
	CString strText = GetItemText(hOrig);

	// Insert new item and copy data
	HTREEITEM hNew = InsertItem(strText, hParent, hInsertAfter);
	ASSERT(hNew != 0);
	item.hItem = hNew;
	VERIFY(SetItem((TVITEM*)&item));
	
	if(ItemHasChildren(hOrig))
		for(HTREEITEM hChild = GetChildItem(hOrig); hChild != 0; hChild = GetNextSiblingItem(hChild))
			CopyItem(hChild, hNew, TVI_LAST);

	return hNew;


}

bool CNMFavoriteTreeCtrl::CanDeleteItem(HTREEITEM hItem)
{
	TRACE1("CNMFavoriteTreeCtrl::CanDeleteItem('%s')\n", LPCTSTR(GetItemText(hItem)));
	return true;
}

void CNMFavoriteTreeCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
	CPoint pt;
	CRect rc;		   
	GetCursorPos(&pt);
	ScreenToClient(&pt);

	if(m_pDragData)
	{		
 	    GetClientRect(&rc);
		

		if(rc.PtInRect(pt))
		{
			TRACE1(" CEditTreeCtrl::OnMouseMove('%s')\n",_T("Mouse In"));  			
		}
		else
		{
			TRACE(traceAppMsg, 0, "Warning: not executing disabled command \n");
			//TRACE1(" CEditTreeCtrl::OnMouseMove('%s')\n",_T("Mouse Out")); 
			CString strDbg;

			strDbg.Format(_T("\r\n##########  BuddyCount in Each Group : %d \r\n"),1234);
			OutputDebugString(strDbg);

			GetParent()->SendMessage(WM_DRAGNDROPUSER, NULL, NULL); 
			DragStop();				

			
			return;
		}

		DragMove();
	}	
	CTreeCtrl::OnMouseMove(nFlags, point);
}

void CNMFavoriteTreeCtrl::DragMove(void)
{
	ASSERT(m_pDragData != 0);
	TRACE1("CNMFavoriteTreeCtrl::DragMove('%s')\n", LPCTSTR(GetItemText(m_pDragData->GetDragItem())));

	EDropHint eHint;
	HTREEITEM hDrop = GetDropTarget(eHint);

	SetDragCursor(hDrop, eHint);	
	TRACE1("CNMFavoriteTreeCtrl::DragMove('%d')\n",eHint);
}

HTREEITEM CNMFavoriteTreeCtrl::GetDropTarget(EDropHint & hint)
{
	ASSERT(m_pDragData != 0);

	CPoint pt;
	GetCursorPos(&pt);
	ScreenToClient(&pt);

	UINT flags;
	HTREEITEM hDrop = HitTest(pt, &flags);
	hint = GetDropHint(flags);
	m_pDragData->SetDropTarget(hDrop);

	if(hDrop == NULL)
		g_nDropFlag = 1;

	HTREEITEM hDrop2 = hDrop;			
	HTREEITEM hmyItem = this->GetSelectedItem();		

	if(m_pDragData->CheckExpand(hDrop))
		Expand(hDrop, TVE_EXPAND);
	
	HTREEITEM hPrev = GetPrevVisibleItem(hDrop);
	if(hPrev)
		EnsureVisible(hPrev);
	HTREEITEM hNext = GetNextVisibleItem(hDrop);
	if(hNext)
		EnsureVisible(hNext);

	
	HTREEITEM hSelItemParent = this->GetParentItem (hmyItem);
	HTREEITEM hItem3 = hmyItem; 
	HTREEITEM hVisibleItem;

	for(hVisibleItem = GetRootItem(); hVisibleItem!=0; hVisibleItem = GetNextVisibleItem(hVisibleItem))
	{
		if(GetItemState(hVisibleItem, UINT(TVIS_SELECTED)) & TVIS_SELECTED)
		{
			if(this->GetParentItem(hVisibleItem) == NULL)
			{			   
				hint = DROP_NODROP;						
				g_nDropFlag = 1;
			}
		}
	}	
		
	int nNumSelected = GetSelectedCount();

	hDrop	= HitTest(pt, &flags);
	hint	= GetDropHint(flags);

	hDrop2	= this->GetParentItem(hDrop);				//Existed Parent 
	if(hDrop2 != NULL)
	{
		hDrop	=	HitTest(pt, &flags);		
		hint	=	DROP_BELOW;		
	}
	else												//Not Existed Parent 	
	{		
		hDrop = HitTest(pt, &flags);		
		hint = DROP_CHILD;
	}

	if(hDrop) {		

		m_pDragData->DragLeave();	// allow updates

		SelectDropTarget(hDrop);

		if(m_pDragData->CheckExpand(hDrop))
			Expand(hDrop, TVE_EXPAND);
		
		HTREEITEM hPrev = GetPrevVisibleItem(hDrop);
		if(hPrev)
			EnsureVisible(hPrev);
		HTREEITEM hNext = GetNextVisibleItem(hDrop);
		if(hNext)
			EnsureVisible(hNext);
		
		// disallow dropping the item here...
		if(IsAncestor(m_pDragData->GetDragItem(), hDrop) || !CanDropItem(m_pDragData->GetDragItem(), hDrop, hint))
			hint = DROP_NODROP;

		m_pDragData->DragEnter(pt);
	} else if(hint != DROP_NODROP && !CanDropItem(m_pDragData->GetDragItem(), hDrop, hint))
		hint = DROP_NODROP;

	HTREEITEM hTragetDrop = hDrop;
	HTREEITEM hSelectedItem = this->GetSelectedItem();
	HTREEITEM hItemDraw = this->GetParentItem (hDrop);

	hSelItemParent = this->GetParentItem (hSelectedItem);

	for(HTREEITEM hItem4 = GetRootItem(); hItem4; hItem4 = GetNextVisibleItem(hItem4))  //현제 보여지는 아이템 개수 동안
	if(GetItemState(hItem4, UINT(TVIS_SELECTED)) & TVIS_SELECTED)
	{
		if(this->GetParentItem(hItem4) == NULL)			
		{			
			TRACE1(" CEditTreeCtrl::GetDropTarget ('%s')\n","보여지는 것들중에 선택된것의 부모가 없을 경우 - Root Node(s)");
			hint = DROP_NODROP;   			
			g_nDropFlag = 1;			
		}
	}

	if(g_nDropFlag == 1)
	{
		hint = DROP_NODROP;
		g_nDropFlag = 0;
	}

// working but...
//		hDrop = HitTest(pt, &flags);
//		hint = GetDropHint(flags);
//		m_pDragData->SetDropTarget(hDrop);

	HTREEITEM hIsRootItem;
	int nCount = 0;

	for(hIsRootItem = GetRootItem(); hIsRootItem!=0; hIsRootItem = GetNextSiblingItem(hIsRootItem))
	{
		TRACE1("Root GetNextSiblingItem is  ('%d')\n",nCount);	  
		   nCount ++;
		    
		if(hmyItem == hIsRootItem)				//선택된 노드가 그룹노드 이면
		{
			g_bCurrentitem = true;		
		}
		if (hIsRootItem == hDrop)
		{	
			g_bTrgetItem = true;			
		}
		//return hDrop;
	}

	if((g_bCurrentitem) && (g_bTrgetItem))
	{
		hint = DROP_BELOW;
		g_bCurrentitem = false;
		g_bTrgetItem = false;
		g_nDropFlag = 0;		
	}

	return hDrop;
}

void CNMFavoriteTreeCtrl::SetDragCursor(HTREEITEM hDropTarget, EDropHint eHint)
{
	if(m_Cursormap.size() == 0)
		CreateCursorMap();

	bool bCtrl = (::GetKeyState(VK_CONTROL) & 0x8000) != 0;

	SetCursor(m_Cursormap[eHint][bCtrl]);
}

CNMFavoriteTreeCtrl::EDropHint CNMFavoriteTreeCtrl::GetDropHint(UINT flags)
{
	EDropHint hint = DROP_NODROP;

	if((flags & TVHT_ONITEMRIGHT))
		hint = DROP_CHILD;

	else if(flags & TVHT_ONITEM) {
		// check whether we should drop below or above		
		CRect rc;
		if(GetItemRect(GetDropHilightItem(), rc, false)) {
			CPoint pt;
			::GetCursorPos(&pt);
			ScreenToClient(&pt);
			if((pt.y - rc.top) > (rc.bottom - pt.y))
				hint = DROP_BELOW;
			else
				hint = DROP_ABOVE;
		} else
			hint = DROP_ABOVE;

	} 
	else if((flags & TVHT_NOWHERE))
		// below the last item
		hint = DROP_BELOW;

	ASSERT(m_pDragData != 0);
	m_pDragData->SetDropHint(hint);

	return hint;
}

void CNMFavoriteTreeCtrl::CreateCursorMap(void)
{
	ASSERT(m_Cursormap.size() == 0);

	HINSTANCE hInst = HINSTANCE(::GetModuleHandle(0));
	HCURSOR hNoDrop    = ::CreateCursor(hInst, HSpotXNoDrop,    HSpotYNoDrop,    32, 32, ANDmaskNoDrop,    XORmaskNoDrop);
	HCURSOR hMoveAbove = ::CreateCursor(hInst, HSpotXMoveAbove, HSpotYMoveAbove, 32, 32, ANDmaskMoveAbove, XORmaskMoveAbove);
	HCURSOR hCopyAbove = ::CreateCursor(hInst, HSpotXCopyAbove, HSpotYCopyAbove, 32, 32, ANDmaskCopyAbove, XORmaskCopyAbove);
	HCURSOR hMoveBelow = ::CreateCursor(hInst, HSpotXMoveBelow, HSpotYMoveBelow, 32, 32, ANDmaskMoveBelow, XORmaskMoveBelow);
	HCURSOR hCopyBelow = ::CreateCursor(hInst, HSpotXCopyBelow, HSpotYCopyBelow, 32, 32, ANDmaskCopyBelow, XORmaskCopyBelow);
	HCURSOR hMoveChild = ::CreateCursor(hInst, HSpotXMoveChild, HSpotYMoveChild, 32, 32, ANDmaskMoveChild, XORmaskMoveChild);
	HCURSOR hCopyChild = ::CreateCursor(hInst, HSpotXCopyChild, HSpotYCopyChild, 32, 32, ANDmaskCopyChild, XORmaskCopyChild);

	ASSERT(hNoDrop    != 0);
	ASSERT(hMoveAbove != 0);
	ASSERT(hCopyAbove != 0);
	ASSERT(hMoveBelow != 0);
	ASSERT(hCopyBelow != 0);
	ASSERT(hMoveChild != 0);
	ASSERT(hCopyChild != 0);

	// The first index is the drop-hint, the second is an indicator for the control-key.
	m_Cursormap[DROP_NODROP][true ] = hNoDrop;
	m_Cursormap[DROP_NODROP][false] = hNoDrop;
	m_Cursormap[DROP_BELOW ][true ] = hCopyBelow;
	m_Cursormap[DROP_BELOW ][false] = hMoveBelow;
	m_Cursormap[DROP_ABOVE ][true ] = hCopyAbove;
	m_Cursormap[DROP_ABOVE ][false] = hMoveAbove;
	m_Cursormap[DROP_CHILD ][true ] = hCopyChild;
	m_Cursormap[DROP_CHILD ][false] = hMoveChild;
}

bool CNMFavoriteTreeCtrl::CanDragItem(TVITEM& item)
{
	//TRACE1("CNMFavoriteTreeCtrl::CanDragItem('%s')\n", item.pszText);
	return true;
}

void CNMFavoriteTreeCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: 여기에 메시지 처리기 코드를 추가 및/또는 기본값을 호출합니다.
	if(m_pDragData)
		DragEnd();
	CTreeCtrl::OnLButtonUp(nFlags, point);
}

bool CNMFavoriteTreeCtrl::HandleKeyDown(WPARAM wParam, LPARAM lParam)
{
	bool bCtrl = (::GetKeyState(VK_CONTROL) & 0x8000) != 0;	
	bool bShift = (::GetKeyState(VK_SHIFT) & 0x8000) == 0;
	HTREEITEM hCur = GetSelectedItem();

	if(GetEditControl() == 0) {
		method fnc = m_Keymap[int(wParam)][bCtrl][bShift];
		if(fnc)
			return (this->*fnc)(hCur);
	}
	switch(int(wParam)) {
		case VK_ESCAPE:
			if(m_pDragData) {
				DragStop();
				return true;
			}
			
		case VK_RETURN:
			if(GetEditControl() != 0) {
				GetEditControl()->SendMessage(WM_KEYDOWN, wParam, lParam);
				return true;
			}
			break;

		default:
			break;
	}
	return false;
}

BOOL CNMFavoriteTreeCtrl::PreTranslateMessage(MSG* pMsg)
{
	switch(pMsg->message) {
		case WM_KEYDOWN:
			if(HandleKeyDown(pMsg->wParam, pMsg->lParam))
				return true;
			break;

		default:
			break;
	}

	return CTreeCtrl::PreTranslateMessage(pMsg);
}

void CNMFavoriteTreeCtrl::OnRButtonDown(UINT nFlags, CPoint point)
{
	// TODO: 여기에 메시지 처리기 코드를 추가 및/또는 기본값을 호출합니다.
	CTreeCtrl::OnRButtonDown(nFlags, point);
}

void CNMFavoriteTreeCtrl::OnRButtonUp(UINT nFlags, CPoint point)
{
	// TODO: 여기에 메시지 처리기 코드를 추가 및/또는 기본값을 호출합니다.
	if(!m_pDragData)
	CTreeCtrl::OnRButtonUp(nFlags, point);
}
BOOL CNMFavoriteTreeCtrl::EditLableOn(void)
{
	DWORD dwStyle = GetStyle();
	ModifyStyle( TVS_EDITLABELS, TVS_EDITLABELS );
	return true;
}

BOOL CNMFavoriteTreeCtrl::EditLableOff(void)
{
	DWORD dwStyle = GetStyle();
	ModifyStyle( TVS_EDITLABELS , 0);
	this->EditLabel((HTREEITEM)this->m_hWnd);
	return true;
}
